Index: uspace/lib/inet/src/iplink.c
===================================================================
--- uspace/lib/inet/src/iplink.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/src/iplink.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -38,7 +38,6 @@
 #include <assert.h>
 #include <errno.h>
+#include <inet/iplink.h>
 #include <inet/addr.h>
-#include <inet/eth_addr.h>
-#include <inet/iplink.h>
 #include <ipc/iplink.h>
 #include <ipc/services.h>
@@ -116,5 +115,5 @@
 	aid_t req = async_send_0(exch, IPLINK_SEND6, &answer);
 
-	errno_t rc = async_data_write_start(exch, &sdu->dest, sizeof(eth_addr_t));
+	errno_t rc = async_data_write_start(exch, &sdu->dest, sizeof(addr48_t));
 	if (rc != EOK) {
 		async_exchange_end(exch);
@@ -154,5 +153,5 @@
 }
 
-errno_t iplink_get_mac48(iplink_t *iplink, eth_addr_t *mac)
+errno_t iplink_get_mac48(iplink_t *iplink, addr48_t *mac)
 {
 	async_exch_t *exch = async_exchange_begin(iplink->sess);
@@ -161,5 +160,5 @@
 	aid_t req = async_send_0(exch, IPLINK_GET_MAC48, &answer);
 
-	errno_t rc = async_data_read_start(exch, mac, sizeof(eth_addr_t));
+	errno_t rc = async_data_read_start(exch, mac, sizeof(addr48_t));
 
 	loc_exchange_end(exch);
@@ -176,5 +175,5 @@
 }
 
-errno_t iplink_set_mac48(iplink_t *iplink, eth_addr_t *mac)
+errno_t iplink_set_mac48(iplink_t *iplink, addr48_t mac)
 {
 	async_exch_t *exch = async_exchange_begin(iplink->sess);
@@ -183,5 +182,5 @@
 	aid_t req = async_send_0(exch, IPLINK_GET_MAC48, &answer);
 
-	errno_t rc = async_data_read_start(exch, mac, sizeof(eth_addr_t));
+	errno_t rc = async_data_read_start(exch, mac, sizeof(addr48_t));
 
 	loc_exchange_end(exch);
@@ -265,9 +264,9 @@
 static void iplink_ev_change_addr(iplink_t *iplink, ipc_call_t *icall)
 {
-	eth_addr_t *addr;
+	addr48_t *addr;
 	size_t size;
 
 	errno_t rc = async_data_write_accept((void **) &addr, false,
-	    sizeof(eth_addr_t), sizeof(eth_addr_t), 0, &size);
+	    sizeof(addr48_t), sizeof(addr48_t), 0, &size);
 	if (rc != EOK) {
 		async_answer_0(icall, rc);
@@ -275,5 +274,5 @@
 	}
 
-	rc = iplink->ev_ops->change_addr(iplink, addr);
+	rc = iplink->ev_ops->change_addr(iplink, *addr);
 	free(addr);
 	async_answer_0(icall, EOK);
Index: uspace/lib/inet/src/iplink_srv.c
===================================================================
--- uspace/lib/inet/src/iplink_srv.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/src/iplink_srv.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -36,5 +36,4 @@
 
 #include <errno.h>
-#include <inet/eth_addr.h>
 #include <ipc/iplink.h>
 #include <stdlib.h>
@@ -52,5 +51,5 @@
 static void iplink_get_mac48_srv(iplink_srv_t *srv, ipc_call_t *icall)
 {
-	eth_addr_t mac;
+	addr48_t mac;
 	errno_t rc = srv->ops->get_mac48(srv, &mac);
 	if (rc != EOK) {
@@ -67,5 +66,5 @@
 	}
 
-	if (size != sizeof(eth_addr_t)) {
+	if (size != sizeof(addr48_t)) {
 		async_answer_0(&call, EINVAL);
 		async_answer_0(icall, EINVAL);
@@ -84,5 +83,5 @@
 	errno_t rc;
 	size_t size;
-	eth_addr_t mac;
+	addr48_t mac;
 
 	ipc_call_t call;
@@ -98,5 +97,5 @@
 	}
 
-	rc = async_data_read_finalize(&call, &mac, sizeof(eth_addr_t));
+	rc = async_data_read_finalize(&call, &mac, sizeof(addr48_t));
 	if (rc != EOK)
 		async_answer_0(&call, rc);
@@ -190,5 +189,5 @@
 	}
 
-	if (size != sizeof(eth_addr_t)) {
+	if (size != sizeof(addr48_t)) {
 		async_answer_0(&call, EINVAL);
 		async_answer_0(icall, EINVAL);
@@ -323,5 +322,5 @@
 }
 
-errno_t iplink_ev_change_addr(iplink_srv_t *srv, eth_addr_t *addr)
+errno_t iplink_ev_change_addr(iplink_srv_t *srv, addr48_t *addr)
 {
 	if (srv->client_sess == NULL)
@@ -333,5 +332,5 @@
 	aid_t req = async_send_0(exch, IPLINK_EV_CHANGE_ADDR, &answer);
 
-	errno_t rc = async_data_write_start(exch, addr, sizeof(eth_addr_t));
+	errno_t rc = async_data_write_start(exch, addr, sizeof(addr48_t));
 	async_exchange_end(exch);
 
Index: uspace/lib/inet/src/tcp.c
===================================================================
--- uspace/lib/inet/src/tcp.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/src/tcp.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/inet/src/udp.c
===================================================================
--- uspace/lib/inet/src/udp.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/src/udp.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/memgfx/include/memgfx/memgc.h
===================================================================
--- uspace/lib/memgfx/include/memgfx/memgc.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/memgfx/include/memgfx/memgc.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -46,5 +46,5 @@
 
 extern errno_t mem_gc_create(gfx_rect_t *, gfx_bitmap_alloc_t *,
-    mem_gc_cb_t *, void *, mem_gc_t **);
+    mem_gc_invalidate_cb_t, mem_gc_update_cb_t, void *, mem_gc_t **);
 extern errno_t mem_gc_delete(mem_gc_t *);
 extern void mem_gc_retarget(mem_gc_t *, gfx_rect_t *, gfx_bitmap_alloc_t *);
Index: uspace/lib/memgfx/include/types/memgfx/memgc.h
===================================================================
--- uspace/lib/memgfx/include/types/memgfx/memgc.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/memgfx/include/types/memgfx/memgc.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -37,6 +37,4 @@
 #define _MEMGFX_TYPES_MEMGC_H
 
-#include <errno.h>
-#include <stdbool.h>
 #include <types/gfx/coord.h>
 
@@ -44,16 +42,6 @@
 typedef struct mem_gc mem_gc_t;
 
-typedef struct {
-	/** Invalidate rectangle */
-	void (*invalidate)(void *, gfx_rect_t *);
-	/** Update display */
-	void (*update)(void *);
-	/** Get cursor position */
-	errno_t (*cursor_get_pos)(void *, gfx_coord2_t *);
-	/** Set cursor position */
-	errno_t (*cursor_set_pos)(void *, gfx_coord2_t *);
-	/** Set cursor visibility */
-	errno_t (*cursor_set_visible)(void *, bool);
-} mem_gc_cb_t;
+typedef void (*mem_gc_invalidate_cb_t)(void *, gfx_rect_t *);
+typedef void (*mem_gc_update_cb_t)(void *);
 
 #endif
Index: uspace/lib/memgfx/meson.build
===================================================================
--- uspace/lib/memgfx/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/memgfx/meson.build	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2021 Jiri Svoboda
+# Copyright (c) 2020 Jiri Svoboda
 # All rights reserved.
 #
@@ -29,6 +29,5 @@
 deps = [ 'gfx' ]
 src = files(
-	'src/memgc.c',
-	'src/xlategc.c'
+	'src/memgc.c'
 )
 
@@ -36,4 +35,3 @@
 	'test/main.c',
 	'test/memgfx.c',
-	'test/xlategc.c'
 )
Index: uspace/lib/memgfx/private/memgc.h
===================================================================
--- uspace/lib/memgfx/private/memgc.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/memgfx/private/memgc.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libmemgfx
+/** @addtogroup libguigfx
  * @{
  */
@@ -53,7 +53,9 @@
 	/** Allocation info */
 	gfx_bitmap_alloc_t alloc;
-	/** Callbacks */
-	mem_gc_cb_t *cb;
-	/** Argument to callbacks */
+	/** Invalidate callback */
+	mem_gc_invalidate_cb_t invalidate;
+	/** Update callback */
+	mem_gc_update_cb_t update;
+	/** Argument to callback */
 	void *cb_arg;
 	/** Current drawing color */
@@ -63,5 +65,5 @@
 /** Bitmap in memory GC */
 typedef struct {
-	/** Containing memory GC */
+	/** Containing canvas GC */
 	struct mem_gc *mgc;
 	/** Allocation info */
Index: uspace/lib/memgfx/src/memgc.c
===================================================================
--- uspace/lib/memgfx/src/memgc.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/memgfx/src/memgc.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -57,7 +57,4 @@
 static errno_t mem_gc_bitmap_render(void *, gfx_rect_t *, gfx_coord2_t *);
 static errno_t mem_gc_bitmap_get_alloc(void *, gfx_bitmap_alloc_t *);
-static errno_t mem_gc_cursor_get_pos(void *, gfx_coord2_t *);
-static errno_t mem_gc_cursor_set_pos(void *, gfx_coord2_t *);
-static errno_t mem_gc_cursor_set_visible(void *, bool);
 static void mem_gc_invalidate_rect(mem_gc_t *, gfx_rect_t *);
 
@@ -70,8 +67,5 @@
 	.bitmap_destroy = mem_gc_bitmap_destroy,
 	.bitmap_render = mem_gc_bitmap_render,
-	.bitmap_get_alloc = mem_gc_bitmap_get_alloc,
-	.cursor_get_pos = mem_gc_cursor_get_pos,
-	.cursor_set_pos = mem_gc_cursor_set_pos,
-	.cursor_set_visible = mem_gc_cursor_set_visible
+	.bitmap_get_alloc = mem_gc_bitmap_get_alloc
 };
 
@@ -108,9 +102,7 @@
 	mem_gc_t *mgc = (mem_gc_t *) arg;
 	uint16_t r, g, b;
-	uint8_t attr;
 
 	gfx_color_get_rgb_i16(color, &r, &g, &b);
-	gfx_color_get_ega(color, &attr);
-	mgc->color = PIXEL(attr, r >> 8, g >> 8, b >> 8);
+	mgc->color = PIXEL(0, r >> 8, g >> 8, b >> 8);
 	return EOK;
 }
@@ -160,5 +152,5 @@
 	mem_gc_t *mgc = (mem_gc_t *) arg;
 
-	mgc->cb->update(mgc->cb_arg);
+	mgc->update(mgc->cb_arg);
 	return EOK;
 }
@@ -170,6 +162,6 @@
  * @param rect Bounding rectangle
  * @param alloc Allocation info
- * @param cb Pointer to memory GC callbacks
- * @param cb_arg Argument to callback functions
+ * @param update_cb Function called to update a rectangle
+ * @param cb_arg Argument to callback function
  * @param rgc Place to store pointer to new memory GC
  *
@@ -177,5 +169,6 @@
  */
 errno_t mem_gc_create(gfx_rect_t *rect, gfx_bitmap_alloc_t *alloc,
-    mem_gc_cb_t *cb, void *cb_arg, mem_gc_t **rgc)
+    mem_gc_invalidate_cb_t invalidate_cb, mem_gc_update_cb_t update_cb,
+    void *cb_arg, mem_gc_t **rgc)
 {
 	mem_gc_t *mgc = NULL;
@@ -198,5 +191,6 @@
 	mgc->alloc = *alloc;
 
-	mgc->cb = cb;
+	mgc->invalidate = invalidate_cb;
+	mgc->update = update_cb;
 	mgc->cb_arg = cb_arg;
 
@@ -252,5 +246,5 @@
 static void mem_gc_invalidate_rect(mem_gc_t *mgc, gfx_rect_t *rect)
 {
-	mgc->cb->invalidate(mgc->cb_arg, rect);
+	mgc->invalidate(mgc->cb_arg, rect);
 }
 
@@ -470,55 +464,4 @@
 }
 
-/** Get cursor position on memory GC.
- *
- * @param arg Memory GC
- * @param pos Place to store position
- *
- * @return EOK on success or an error code
- */
-static errno_t mem_gc_cursor_get_pos(void *arg, gfx_coord2_t *pos)
-{
-	mem_gc_t *mgc = (mem_gc_t *) arg;
-
-	if (mgc->cb->cursor_get_pos != NULL)
-		return mgc->cb->cursor_get_pos(mgc->cb_arg, pos);
-	else
-		return ENOTSUP;
-}
-
-/** Set cursor position on memory GC.
- *
- * @param arg Memory GC
- * @param pos New position
- *
- * @return EOK on success or an error code
- */
-static errno_t mem_gc_cursor_set_pos(void *arg, gfx_coord2_t *pos)
-{
-	mem_gc_t *mgc = (mem_gc_t *) arg;
-
-	if (mgc->cb->cursor_set_pos != NULL)
-		return mgc->cb->cursor_set_pos(mgc->cb_arg, pos);
-	else
-		return ENOTSUP;
-}
-
-/** Set cursor visibility on memory GC.
- *
- * @param arg Memory GC
- * @param visible @c true iff cursor should be made visible
- *
- * @return EOK on success or an error code
- */
-static errno_t mem_gc_cursor_set_visible(void *arg, bool visible)
-{
-	mem_gc_t *mgc = (mem_gc_t *) arg;
-
-	if (mgc->cb->cursor_set_visible != NULL)
-		return mgc->cb->cursor_set_visible(mgc->cb_arg, visible);
-	else
-		return ENOTSUP;
-}
-
 /** @}
  */
Index: uspace/lib/memgfx/test/main.c
===================================================================
--- uspace/lib/memgfx/test/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/memgfx/test/main.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2020 Jiri Svoboda
  * All rights reserved.
  *
@@ -32,5 +32,4 @@
 
 PCUT_IMPORT(memgfx);
-PCUT_IMPORT(xlategc);
 
 PCUT_MAIN();
Index: uspace/lib/memgfx/test/memgfx.c
===================================================================
--- uspace/lib/memgfx/test/memgfx.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/memgfx/test/memgfx.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -32,5 +32,4 @@
 #include <gfx/coord.h>
 #include <gfx/context.h>
-#include <gfx/cursor.h>
 #include <gfx/render.h>
 #include <io/pixelmap.h>
@@ -45,19 +44,6 @@
 static void test_invalidate_rect(void *arg, gfx_rect_t *rect);
 static void test_update(void *arg);
-static errno_t test_cursor_get_pos(void *arg, gfx_coord2_t *);
-static errno_t test_cursor_set_pos(void *arg, gfx_coord2_t *);
-static errno_t test_cursor_set_visible(void *arg, bool);
-
-static mem_gc_cb_t test_mem_gc_cb = {
-	.invalidate = test_invalidate_rect,
-	.update = test_update,
-	.cursor_get_pos = test_cursor_get_pos,
-	.cursor_set_pos = test_cursor_set_pos,
-	.cursor_set_visible = test_cursor_set_visible
-};
 
 typedef struct {
-	/** Return code to return */
-	errno_t rc;
 	/** True if invalidate was called */
 	bool invalidate_called;
@@ -66,16 +52,4 @@
 	/** True if update was called */
 	bool update_called;
-	/** True if cursor_get_pos was called */
-	bool cursor_get_pos_called;
-	/** Position to return from cursor_get_pos */
-	gfx_coord2_t get_pos_pos;
-	/** True if cursor_set_pos was called */
-	bool cursor_set_pos_called;
-	/** Position passed to cursor_set_pos */
-	gfx_coord2_t set_pos_pos;
-	/** True if cursor_set_visible was called */
-	bool cursor_set_visible_called;
-	/** Value passed to cursor_set_visible */
-	bool set_visible_vis;
 } test_resp_t;
 
@@ -98,5 +72,5 @@
 	PCUT_ASSERT_NOT_NULL(alloc.pixels);
 
-	rc = mem_gc_create(&rect, &alloc, NULL, NULL, &mgc);
+	rc = mem_gc_create(&rect, &alloc, NULL, NULL, NULL, &mgc);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -132,5 +106,6 @@
 	PCUT_ASSERT_NOT_NULL(alloc.pixels);
 
-	rc = mem_gc_create(&rect, &alloc, &test_mem_gc_cb, &resp, &mgc);
+	rc = mem_gc_create(&rect, &alloc, test_invalidate_rect,
+	    test_update, &resp, &mgc);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -212,5 +187,6 @@
 	PCUT_ASSERT_NOT_NULL(alloc.pixels);
 
-	rc = mem_gc_create(&rect, &alloc, &test_mem_gc_cb, &resp, &mgc);
+	rc = mem_gc_create(&rect, &alloc, test_invalidate_rect,
+	    test_update, &resp, &mgc);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -301,5 +277,6 @@
 	PCUT_ASSERT_NOT_NULL(alloc.pixels);
 
-	rc = mem_gc_create(&rect, &alloc, &test_mem_gc_cb, &resp, &mgc);
+	rc = mem_gc_create(&rect, &alloc, test_invalidate_rect,
+	    test_update, &resp, &mgc);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -317,135 +294,4 @@
 }
 
-/** Test gfx_cursor_get_pos() on a memory GC */
-PCUT_TEST(gfx_cursor_get_pos)
-{
-	mem_gc_t *mgc;
-	gfx_rect_t rect;
-	gfx_bitmap_alloc_t alloc;
-	gfx_coord2_t pos;
-	gfx_context_t *gc;
-	test_resp_t resp;
-	errno_t rc;
-
-	/* Bounding rectangle for memory GC */
-	rect.p0.x = 0;
-	rect.p0.y = 0;
-	rect.p1.x = 10;
-	rect.p1.y = 10;
-
-	alloc.pitch = (rect.p1.x - rect.p0.x) * sizeof(uint32_t);
-	alloc.off0 = 0;
-	alloc.pixels = calloc(1, alloc.pitch * (rect.p1.y - rect.p0.y));
-	PCUT_ASSERT_NOT_NULL(alloc.pixels);
-
-	rc = mem_gc_create(&rect, &alloc, &test_mem_gc_cb, &resp, &mgc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	gc = mem_gc_get_ctx(mgc);
-	PCUT_ASSERT_NOT_NULL(gc);
-
-	memset(&resp, 0, sizeof(resp));
-	resp.rc = EOK;
-	resp.get_pos_pos.x = 1;
-	resp.get_pos_pos.y = 2;
-	PCUT_ASSERT_FALSE(resp.cursor_get_pos_called);
-
-	rc = gfx_cursor_get_pos(gc, &pos);
-	PCUT_ASSERT_TRUE(resp.cursor_get_pos_called);
-	PCUT_ASSERT_INT_EQUALS(resp.get_pos_pos.x, pos.x);
-	PCUT_ASSERT_INT_EQUALS(resp.get_pos_pos.y, pos.y);
-
-	mem_gc_delete(mgc);
-	free(alloc.pixels);
-}
-
-/** Test gfx_cursor_set_pos() on a memory GC */
-PCUT_TEST(gfx_cursor_set_pos)
-{
-	mem_gc_t *mgc;
-	gfx_rect_t rect;
-	gfx_bitmap_alloc_t alloc;
-	gfx_coord2_t pos;
-	gfx_context_t *gc;
-	test_resp_t resp;
-	errno_t rc;
-
-	/* Bounding rectangle for memory GC */
-	rect.p0.x = 0;
-	rect.p0.y = 0;
-	rect.p1.x = 10;
-	rect.p1.y = 10;
-
-	alloc.pitch = (rect.p1.x - rect.p0.x) * sizeof(uint32_t);
-	alloc.off0 = 0;
-	alloc.pixels = calloc(1, alloc.pitch * (rect.p1.y - rect.p0.y));
-	PCUT_ASSERT_NOT_NULL(alloc.pixels);
-
-	rc = mem_gc_create(&rect, &alloc, &test_mem_gc_cb, &resp, &mgc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	gc = mem_gc_get_ctx(mgc);
-	PCUT_ASSERT_NOT_NULL(gc);
-
-	memset(&resp, 0, sizeof(resp));
-	resp.rc = EOK;
-	pos.x = 1;
-	pos.y = 2;
-	PCUT_ASSERT_FALSE(resp.cursor_set_pos_called);
-
-	rc = gfx_cursor_set_pos(gc, &pos);
-	PCUT_ASSERT_TRUE(resp.cursor_set_pos_called);
-	PCUT_ASSERT_INT_EQUALS(pos.x, resp.set_pos_pos.x);
-	PCUT_ASSERT_INT_EQUALS(pos.y, resp.set_pos_pos.y);
-
-	mem_gc_delete(mgc);
-	free(alloc.pixels);
-}
-
-/** Test gfx_cursor_set_visible() on a memory GC */
-PCUT_TEST(gfx_cursor_set_visible)
-{
-	mem_gc_t *mgc;
-	gfx_rect_t rect;
-	gfx_bitmap_alloc_t alloc;
-	gfx_context_t *gc;
-	test_resp_t resp;
-	errno_t rc;
-
-	/* Bounding rectangle for memory GC */
-	rect.p0.x = 0;
-	rect.p0.y = 0;
-	rect.p1.x = 10;
-	rect.p1.y = 10;
-
-	alloc.pitch = (rect.p1.x - rect.p0.x) * sizeof(uint32_t);
-	alloc.off0 = 0;
-	alloc.pixels = calloc(1, alloc.pitch * (rect.p1.y - rect.p0.y));
-	PCUT_ASSERT_NOT_NULL(alloc.pixels);
-
-	rc = mem_gc_create(&rect, &alloc, &test_mem_gc_cb, &resp, &mgc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	gc = mem_gc_get_ctx(mgc);
-	PCUT_ASSERT_NOT_NULL(gc);
-
-	memset(&resp, 0, sizeof(resp));
-	resp.rc = EOK;
-	PCUT_ASSERT_FALSE(resp.cursor_set_visible_called);
-
-	rc = gfx_cursor_set_visible(gc, true);
-	PCUT_ASSERT_TRUE(resp.cursor_set_visible_called);
-	PCUT_ASSERT_TRUE(resp.set_visible_vis);
-
-	resp.cursor_set_visible_called = false;
-
-	rc = gfx_cursor_set_visible(gc, false);
-	PCUT_ASSERT_TRUE(resp.cursor_set_visible_called);
-	PCUT_ASSERT_FALSE(resp.set_visible_vis);
-
-	mem_gc_delete(mgc);
-	free(alloc.pixels);
-}
-
 /** Called by memory GC when a rectangle is modified. */
 static void test_invalidate_rect(void *arg, gfx_rect_t *rect)
@@ -465,33 +311,3 @@
 }
 
-/** Called by memory GC when cursor_get_pos is called. */
-static errno_t test_cursor_get_pos(void *arg, gfx_coord2_t *pos)
-{
-	test_resp_t *resp = (test_resp_t *)arg;
-
-	resp->cursor_get_pos_called = true;
-	*pos = resp->get_pos_pos;
-	return resp->rc;
-}
-
-/** Called by memory GC when cursor_set_pos is called. */
-static errno_t test_cursor_set_pos(void *arg, gfx_coord2_t *pos)
-{
-	test_resp_t *resp = (test_resp_t *)arg;
-
-	resp->cursor_set_pos_called = true;
-	resp->set_pos_pos = *pos;
-	return resp->rc;
-}
-
-/** Called by memory GC when cursor_set_visible is called. */
-static errno_t test_cursor_set_visible(void *arg, bool visible)
-{
-	test_resp_t *resp = (test_resp_t *)arg;
-
-	resp->cursor_set_visible_called = true;
-	resp->set_visible_vis = visible;
-	return resp->rc;
-}
-
 PCUT_EXPORT(memgfx);
Index: uspace/lib/meson.build
===================================================================
--- uspace/lib/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/meson.build	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -57,5 +57,4 @@
 	'block',
 	'clui',
-	'codepage',
 	'compress',
 	'cpp',
Index: uspace/lib/ui/include/types/ui/control.h
===================================================================
--- uspace/lib/ui/include/types/ui/control.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/types/ui/control.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2020 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,5 +38,4 @@
 
 #include <errno.h>
-#include <io/kbd_event.h>
 #include <io/pos_event.h>
 #include <types/ui/event.h>
@@ -51,6 +50,4 @@
 	/** Paint */
 	errno_t (*paint)(void *);
-	/** Keyboard event */
-	ui_evclaim_t (*kbd_event)(void *, kbd_event_t *);
 	/** Position event */
 	ui_evclaim_t (*pos_event)(void *, pos_event_t *);
Index: uspace/lib/ui/include/types/ui/paint.h
===================================================================
--- uspace/lib/ui/include/types/ui/paint.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/types/ui/paint.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -49,36 +49,4 @@
 } ui_fcircle_part_t;
 
-/** Box characters for a particular box style.
- *
- * The first coordinate selects top, center, bottom,
- * the second coordinate selects left, center, right.
- * The top/bottom, left/right characters correpsond to corners,
- * the characters with one center coordinate correspond to edges:
- *
- *    0   1   2
- * 0 '+' '-' '+'
- * 1 ' |' ' ' '|'
- * 2 '+' '-' '+'
- *
- */
-typedef struct {
-	const char *c[3][3];
-} ui_box_chars_t;
-
-/** Horizontal brace characters for a particular box style. */
-typedef struct {
-	const char *start;
-	const char *middle;
-	const char *end;
-} ui_brace_chars_t;
-
-/** Box style */
-typedef enum {
-	/** Single box */
-	ui_box_single,
-	/** Double box */
-	ui_box_double
-} ui_box_style_t;
-
 #endif
 
Index: uspace/lib/ui/include/types/ui/ui.h
===================================================================
--- uspace/lib/ui/include/types/ui/ui.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/types/ui/ui.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -42,10 +42,6 @@
 typedef struct ui ui_t;
 
-/** Use the default display service (argument to ui_create()) */
+/** Use the default display service (argument to ui_create() */
 #define UI_DISPLAY_DEFAULT NULL
-/** Use the default console service (argument to ui_create()) */
-#define UI_CONSOLE_DEFAULT "cons@"
-/** Use dummy output (argument to ui_create()) */
-#define UI_DISPLAY_NULL "null@"
 
 /** Window system */
@@ -56,7 +52,5 @@
 	ui_ws_display,
 	/** Console */
-	ui_ws_console,
-	/** Dummy output */
-	ui_ws_null
+	ui_ws_console
 } ui_winsys_t;
 
Index: uspace/lib/ui/include/ui/control.h
===================================================================
--- uspace/lib/ui/include/ui/control.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/control.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2020 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,5 +38,4 @@
 
 #include <errno.h>
-#include <io/kbd_event.h>
 #include <io/pos_event.h>
 #include <types/ui/control.h>
@@ -47,5 +46,4 @@
 extern void ui_control_destroy(ui_control_t *);
 extern errno_t ui_control_paint(ui_control_t *);
-extern ui_evclaim_t ui_control_kbd_event(ui_control_t *, kbd_event_t *);
 extern ui_evclaim_t ui_control_pos_event(ui_control_t *, pos_event_t *);
 extern void ui_control_unfocus(ui_control_t *);
Index: uspace/lib/ui/include/ui/entry.h
===================================================================
--- uspace/lib/ui/include/ui/entry.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/entry.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -50,21 +50,6 @@
 extern void ui_entry_set_rect(ui_entry_t *, gfx_rect_t *);
 extern void ui_entry_set_halign(ui_entry_t *, gfx_halign_t);
-extern void ui_entry_set_read_only(ui_entry_t *, bool);
 extern errno_t ui_entry_set_text(ui_entry_t *, const char *);
-extern const char *ui_entry_get_text(ui_entry_t *);
 extern errno_t ui_entry_paint(ui_entry_t *);
-extern void ui_entry_activate(ui_entry_t *);
-extern void ui_entry_deactivate(ui_entry_t *);
-extern void ui_entry_backspace(ui_entry_t *);
-extern void ui_entry_delete(ui_entry_t *);
-extern void ui_entry_copy(ui_entry_t *);
-extern void ui_entry_cut(ui_entry_t *);
-extern void ui_entry_paste(ui_entry_t *);
-extern void ui_entry_seek_start(ui_entry_t *, bool);
-extern void ui_entry_seek_end(ui_entry_t *, bool);
-extern void ui_entry_seek_prev_char(ui_entry_t *, bool);
-extern void ui_entry_seek_next_char(ui_entry_t *, bool);
-extern ui_evclaim_t ui_entry_kbd_event(ui_entry_t *, kbd_event_t *);
-extern ui_evclaim_t ui_entry_pos_event(ui_entry_t *, pos_event_t *);
 
 #endif
Index: uspace/lib/ui/include/ui/fixed.h
===================================================================
--- uspace/lib/ui/include/ui/fixed.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/fixed.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2020 Jiri Svoboda
  * All rights reserved.
  *
@@ -49,5 +49,4 @@
 extern void ui_fixed_remove(ui_fixed_t *, ui_control_t *);
 extern errno_t ui_fixed_paint(ui_fixed_t *);
-extern ui_evclaim_t ui_fixed_kbd_event(ui_fixed_t *, kbd_event_t *);
 extern ui_evclaim_t ui_fixed_pos_event(ui_fixed_t *, pos_event_t *);
 extern void ui_fixed_unfocus(ui_fixed_t *);
Index: uspace/lib/ui/include/ui/label.h
===================================================================
--- uspace/lib/ui/include/ui/label.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/label.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2020 Jiri Svoboda
  * All rights reserved.
  *
@@ -50,5 +50,4 @@
 extern void ui_label_set_rect(ui_label_t *, gfx_rect_t *);
 extern void ui_label_set_halign(ui_label_t *, gfx_halign_t);
-extern void ui_label_set_valign(ui_label_t *, gfx_valign_t);
 extern errno_t ui_label_set_text(ui_label_t *, const char *);
 extern errno_t ui_label_paint(ui_label_t *);
Index: uspace/lib/ui/include/ui/msgdialog.h
===================================================================
--- uspace/lib/ui/include/ui/msgdialog.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/msgdialog.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -31,9 +31,9 @@
  */
 /**
- * @file Message dialog
+ * @file Message Dialog
  */
 
-#ifndef _UI_MSGDIALOG_H
-#define _UI_MSGDIALOG_H
+#ifndef _UI_MSG_DIALOG_H
+#define _UI_MSG_DIALOG_H
 
 #include <errno.h>
Index: uspace/lib/ui/include/ui/paint.h
===================================================================
--- uspace/lib/ui/include/ui/paint.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/paint.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -45,9 +45,5 @@
 extern errno_t ui_paint_bevel(gfx_context_t *, gfx_rect_t *, gfx_color_t *,
     gfx_color_t *, gfx_coord_t, gfx_rect_t *);
-extern void ui_paint_get_bevel_inside(gfx_context_t *, gfx_rect_t *,
-    gfx_coord_t, gfx_rect_t *);
 extern errno_t ui_paint_inset_frame(ui_resource_t *, gfx_rect_t *,
-    gfx_rect_t *);
-extern void ui_paint_get_inset_frame_inside(ui_resource_t *, gfx_rect_t *,
     gfx_rect_t *);
 extern errno_t ui_paint_outset_frame(ui_resource_t *, gfx_rect_t *,
@@ -55,8 +51,4 @@
 extern errno_t ui_paint_filled_circle(gfx_context_t *, gfx_coord2_t *,
     gfx_coord_t, ui_fcircle_part_t);
-extern errno_t ui_paint_text_box(ui_resource_t *, gfx_rect_t *,
-    ui_box_style_t, gfx_color_t *);
-extern errno_t ui_paint_text_hbrace(ui_resource_t *, gfx_rect_t *,
-    ui_box_style_t, gfx_color_t *);
 
 #endif
Index: uspace/lib/ui/include/ui/rbutton.h
===================================================================
--- uspace/lib/ui/include/ui/rbutton.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/rbutton.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -61,5 +61,4 @@
 extern void ui_rbutton_enter(ui_rbutton_t *);
 extern void ui_rbutton_leave(ui_rbutton_t *);
-extern void ui_rbutton_select(ui_rbutton_t *);
 extern void ui_rbutton_selected(ui_rbutton_t *);
 extern ui_evclaim_t ui_rbutton_pos_event(ui_rbutton_t *, pos_event_t *);
Index: uspace/lib/ui/include/ui/resource.h
===================================================================
--- uspace/lib/ui/include/ui/resource.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/resource.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -39,5 +39,4 @@
 #include <errno.h>
 #include <gfx/context.h>
-#include <gfx/font.h>
 #include <stdbool.h>
 #include <types/ui/resource.h>
@@ -48,5 +47,4 @@
     void *);
 extern void ui_resource_expose(ui_resource_t *);
-extern gfx_font_t *ui_resource_get_font(ui_resource_t *);
 
 #endif
Index: uspace/lib/ui/include/ui/window.h
===================================================================
--- uspace/lib/ui/include/ui/window.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/window.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -40,5 +40,4 @@
 #include <gfx/context.h>
 #include <gfx/coord.h>
-#include <io/kbd_event.h>
 #include <io/pos_event.h>
 #include <types/ui/control.h>
@@ -56,5 +55,4 @@
 extern ui_window_t *ui_window_get_active(ui_t *);
 extern errno_t ui_window_resize(ui_window_t *, gfx_rect_t *);
-extern ui_t *ui_window_get_ui(ui_window_t *);
 extern ui_resource_t *ui_window_get_res(ui_window_t *);
 extern gfx_context_t *ui_window_get_gc(ui_window_t *);
@@ -64,5 +62,4 @@
 extern void ui_window_set_ctl_cursor(ui_window_t *, ui_stock_cursor_t);
 extern errno_t ui_window_paint(ui_window_t *);
-extern void ui_window_def_kbd(ui_window_t *, kbd_event_t *);
 extern errno_t ui_window_def_paint(ui_window_t *);
 extern void ui_window_def_pos(ui_window_t *, pos_event_t *);
Index: uspace/lib/ui/meson.build
===================================================================
--- uspace/lib/ui/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/meson.build	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -33,5 +33,4 @@
 	'src/dummygc.c',
 	'src/entry.c',
-	'src/filedialog.c',
 	'src/fixed.c',
 	'src/image.c',
@@ -44,5 +43,4 @@
 	'src/pbutton.c',
 	'src/popup.c',
-	'src/promptdialog.c',
 	'src/rbutton.c',
 	'src/resource.c',
@@ -57,5 +55,4 @@
 	'test/control.c',
 	'test/entry.c',
-	'test/filedialog.c',
 	'test/fixed.c',
 	'test/image.c',
@@ -69,5 +66,4 @@
 	'test/pbutton.c',
 	'test/popup.c',
-	'test/promptdialog.c',
 	'test/rbutton.c',
 	'test/resource.c',
Index: uspace/lib/ui/private/checkbox.h
===================================================================
--- uspace/lib/ui/private/checkbox.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/private/checkbox.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2020 Jiri Svoboda
  * All rights reserved.
  *
@@ -66,7 +66,4 @@
 };
 
-extern errno_t ui_checkbox_paint_gfx(ui_checkbox_t *);
-extern errno_t ui_checkbox_paint_text(ui_checkbox_t *);
-
 #endif
 
